import pandas as pd
import numpy as np
import matplotlib.pyplot as plt
import random
import math

def centers(N, c, p, x, u, v_old):
    for i in range(c):
        for j in range(p):
            s1 = 0
            s2 = 0
            for k in range(N):
                s1 += u[k, i] * x[k, j]
                s2 += u[k, i]
            if s2 == 0:
                v[i, j] = v_old[i, j]
            else:
                v[i, j] = s1 / s2
    return v


def distances(N, c, p, x, v):
    D = np.zeros((N, c))
    for k in range(N):
        for i in range(c):
            s = 0;
            for j in range(p):
                s = s + pow((x[k, j] - v[i, j]), 2)
            D[k, i] = math.sqrt(s)
    return D


def membership(N, c, D):
    u = np.zeros((N, c))
    for k in range(N):
        id = np.argmin(D[k, :])
        u[k, id] = 1
    return u
  

df = pd.read_excel(r'Data.xlsx')
x = df.to_numpy()
N = len(x)
p = len(x[0])
c = 4
e = 0.001

v = np.zeros((c, p))

x_min = x.min(axis=0)
x_max = x.max(axis=0)

for i in range(c):
  for j in range(p):
    v[i,j] = x_min[j] + random.random() * (x_max[j] - x_min[j])

E = 1
iteration = 0
while E>e:
  iteration += 1
  v_old = np.copy(v)
  D = distances(N, c, p, x, v)
  u = membership(N, c, D)
  v = centers(N, c, p, x, u, v_old)

  dist = np.zeros(c)
  for i in range(c):
      s = 0
      for j in range(p):
          s = s + pow(v[i, j] - v_old[i, j], 2)
      print(s)
      dist[i] = math.sqrt(s)
  E = max(dist)
  print (E)

colors = np.zeros(N)
for i in range(N):
    for j in range(c):
        if u[i, j] == 1:
            colors[i] = j+2

#add centers to plot
xx = np.concatenate((x, v), axis=0)
for i in range(c):
    colors = np.append(colors, 0)

plt.scatter(xx[:, 0], xx[:, 1], c=colors)
plt.show()
